/*
 *  MPEG-1 Real Time Encoder
 *
 *  Copyright (C) 1999-2000 Michael H. Schimek
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: dtest.c,v 1.3 2000/06/08 18:53:34 michael Exp $ */

#include "ieee.h"
#include "../mpeg.h"
#include "../../misc.h"
#include "../../mmx.h"

char *		my_name;
int		verbose = 0;

short		mblock[4][6][8][8];

void
aan_double_idct(short block[8][8]);
void
aan_double_q_fdct(int q, short block[8][8]);
void
aan2_double_q_fdct(int q, short block[8][8]);
void
aan2_double_fdct(short block[8][8]);

extern void
mmx_q_fdct_intra(int q, short block[8][8]);
extern void
mmx_q_fdct_inter(int q, short block[8][8]);

void
t2_double_idct(short block[8][8]);


extern double sum[8][8];

int
main(int ac, char **av)
{
	int iterations = 10000;
	int sign = 1;
	unsigned int q_pattern = 0x5555FFFE;
	int i;

	my_name = av[0];

	if (ac > 1) iterations = atoi(av[1]);
	if (ac > 2) sign = atoi(av[2]);

//	randomize = rake_pattern;
//	ieee_idct_test("aan_double_idct", aan_double_idct, -255, +255, sign, iterations);
	randomize = ieee_randomize;
	ieee_idct_test("T2_double_idct", t2_double_idct, -255, +255, sign, iterations);

#if 0
	randomize = ieee_randomize;
	printf("mmx_q_fdct_intra random pattern q = 2\n");
	q_fdct_test(mmx_q_fdct_intra, mpeg_intra_quant, -128, +127, sign, iterations, 0x4);
	printf("mmx_q_fdct_intra random pattern q = 2 ... 16\n");
	q_fdct_test(mmx_q_fdct_intra, mpeg_intra_quant, -128, +127, sign, iterations / 16, 0x1FFFC);
	randomize = rake_pattern;
	printf("mmx_q_fdct_intra overflow test\n");
	q_fdct_test(mmx_q_fdct_intra, mpeg_intra_quant, -128, +127, sign, 2000, 0x5555FFFC);
#endif
#if 0
	randomize = ieee_randomize;
	printf("mmx_q_fdct_inter random pattern q = 1\n");
	q_fdct_test(mmx_q_fdct_inter, mpeg_inter_quant, -255, +255, sign, iterations, 0x2);
	printf("mmx_q_fdct_inter random pattern q = 1 ... 16\n");
	q_fdct_test(mmx_q_fdct_inter, mpeg_inter_quant, -255, +255, sign, iterations / 16, 0x1FFFC);
	printf("mmx_q_fdct_inter random small delta q = 1\n");
	q_fdct_test(mmx_q_fdct_inter, mpeg_inter_quant, -5, +5, sign, iterations, 0x2);
	randomize = rake_pattern;
	printf("mmx_q_fdct_inter overflow test\n");
	q_fdct_test(mmx_q_fdct_inter, mpeg_inter_quant, -255, +255, sign, 1000, 0xFFFFFFFC);
#endif

	return EXIT_SUCCESS;
}
